; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 800
WINDOWHEIGHT = 600
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW \
	or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	TranslateMessage,edi
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	hFile:dword	;handle of file
local	szReadWrite:dword	;number of bytes actually read or write
local	w:dword
local	h:dword

        mov	hWin,rcx
        xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_TIMER
	je      wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_D
	jne	@f
	or	Daytime,1
	jmp	@1
@@:	cmp	al,VK_N
	jne	wmBYE
	and	Daytime,0
@1:	invoke	InvalidateRect,,0,0
	jmp	wmBYE
;---------------------------------------------
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
        invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,3145728
	mov	texture1,eax
        invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,3145728
	mov	texture2,eax
;GLInit----------------------------------
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,rbx
        mov	hFile,eax
	mov	edx,texture1
	lea	r9,szReadWrite
        invoke	ReadFile,eax,,3145728,,0
	mov	ecx,hFile
        invoke	CloseHandle
	mov	ecx,offset FileName3
	invoke	CreateFile,,GENERIC_READ or GENERIC_WRITE,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,rbx
        mov	hFile,eax
	mov	edx,texture2
	lea	r9,szReadWrite
        invoke	ReadFile,eax,,3145728,,0
	mov	ecx,hFile
        invoke	CloseHandle
;-------------------------------------------------------------------
;      (z-)
	invoke	glEnable,GL_DEPTH_TEST
; 
	invoke glEnable,GL_TEXTURE_2D
;   GL_LIGHT0 (   )
	invoke	glEnable,GL_LIGHT0
; 
	invoke	glEnable,GL_LIGHTING
;-----------------------------------------------------------------------
	invoke glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
;     (linear)
	invoke glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	xorps	xmm3,xmm3	;z 	
	xorps	xmm2,xmm2	;y
	movq	xmm1,constd1	;x
	movq	xmm0,constd90
	invoke	glRotated
        jmp	wmBYE
wmTIMER:movq	xmm0,delta
	subsd	xmm0,constd0_5
        movq	delta,xmm0
	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmSIZE:;     	
	movzx	r8d,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0
	invoke	glMatrixMode,GL_PROJECTION
	invoke	glLoadIdentity
	cvtsi2sd xmm0,w
	cvtsi2sd xmm1,h
	divsd	xmm0,xmm1
;	movsd	ratio,xmm0

	movq	xmm3,constd5;top=5                     -5,5+----------+ 5, 5
	movsd	xmm1,constd5;right=5                       |          |
	mulsd	xmm1,xmm0;ratio                            |          |
	xorps	xmm2,xmm2;                                 |          | 
	subsd	xmm2,xmm3;bottom=-5                        |          |
	xorps	xmm0,xmm0;                                 |          |
	subsd	xmm0,xmm1;left=-5                     -5,-5+----------+ 5,-5
	invoke	glOrtho,,,,,constd1,constd12;nearVal,farVal

	xorps	xmm3,xmm3;centerX
	movd	xmm2,constd5;eyeZ
	xorps	xmm1,xmm1;eyeY
	xorps	xmm0,xmm0;eyeX
	invoke	gluLookAt,,,,,rbx,rbx,rbx,constd1,rbx;centerY, centerZ,
  	invoke	glMatrixMode,GL_MODELVIEW;    
; ()
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; 1024x1024x24bpp    texture (raw )
	mov	al,oldDaytime
	cmp	Daytime,al
	je	@f
	or	al,al
	jne	@2
	mov	eax,texture1
	jmp	@3
@2:	mov	eax,texture2
@3:	xor	oldDaytime,1
	mov	[rsp+40h],rax
	invoke glTexImage2D,GL_TEXTURE_2D,0,3,1024,1024,rbx,GL_RGB,\
	GL_UNSIGNED_BYTE
;  
@@:     invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	invoke	gluNewQuadric
        mov	quadObj,rax
        invoke	gluQuadricTexture,eax,GL_TRUE
	invoke	gluQuadricDrawStyle,quadObj, GLU_FILL
	movq	xmm2,constd1
	movsd	xmm1,xmm2
	movsd	xmm0,xmm2;red
	invoke	glColor3d
	invoke	glPushMatrix;  
	
        movq	xmm3,constd1	;z 	
	xorps	xmm2,xmm2	;y
	xorps	xmm1,xmm1	;x
	movq	xmm0,delta
	invoke	glRotated

	movq	xmm1,constd3
	invoke	gluSphere,quadObj,,16,16
        invoke	glPopMatrix
	invoke	gluDeleteQuadric,quadObj
;   
        invoke  glFlush
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?;  
PixFrm	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

szClassName	db "Uncle Remus tales:#40 OpenGL - Sphere2",0
FileName	db "br_Rabbit3.cur",0
;double----------------------------
constd0_5	dq 0.5
constd1		dq 1.0
constd3		dq 3.0
constd5		dq 5.0
constd12	dq 12.0
constd90	dq 90.0
quadObj		dq ?
FileName2	db "Earth1.raw",0
FileName3	db "night1.raw",0
texture1	dd ?
texture2	dd ?
delta		dq 0
Daytime		db TRUE
oldDaytime	db FALSE
;ratio		dq 1.33333333333333333333333333333
end